/***************************************
This program was produced by the
CodeWizardAVR V1.0.0.8v Evaluation
Automatic Program Generator
 Copyright 1998-2000
Pavel Haiduc, HP InfoTech S.R.L.
http://infotech.ir.ro
e-mail:dhptechn@ir.ro , hpinfotech@mail.com

Project : 
Version : 
Date    : 06.11.2000
Author  : 
Company : 
Comments: 


Chip type        : AT90S2313
Clock frequency  : 10,000000 MHz
Memory model     : Tiny
Internal RAM size: 128
External RAM size: 0
Data Stack size  : 32
***************************************/

#include <90s2313.h>

// Standard Input/Output functions
#include <stdio.h>

// Declare your global variables here

// Konstantendefinitionen
#define Slaveadresse 		0xC4   	// Eigene Adresse
#define command_switch	 	0x01	// Kommando Lampe sofort ansteuern
#define command_dimm_abs	0x02	// Kommando Lampe kontinuierlich absolut dimmen
#define command_dimm_rel 	0x03	// Kommando Lampe kontinuierlich relativ dimmen
#define command_ident		0x04	// Gert Identifizieren

char 	Kommando;							// Das empfangene Kommando
char	Datum;                              // Empfangenes Datum

char 	trigger_count=0;					// Triggerzhler 
char	ticker_count=0;						// Anzahl der Aufrufe (Dauer feststellen)

// Dimmerwerte in 0-100% sowie Dauer in 0.1sek.-Schritten
int	startwert,endwert,dauer;
                                            
// Timer 0 overflow interrupt service routine      
// Wird bei 10 MHz etwa alle 26ms angesprungen
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
  trigger_count++;
  if (trigger_count>3)	// Diese Schleife wird also 10* pro sec. abgearbeitet
 	{
 		trigger_count=0; 
		ticker_count++;                                    
				
		if (ticker_count>dauer)
		
		 {
		   ticker_count=0;          
		   if (startwert>endwert)    
		    OCR1AL--;  else		// Neuen Timerwert setzen
			OCR1AL++;
		    	    
	    	 // Jetzt noch kontrollieren, ob der Dimmvorgang abgeschlossen wurde
	    	 if (OCR1L==endwert) 
	    	 {
		    	TCCR0=0x00; // Timer 0 anhalten
		    	ticker_count=0;
		     }
		
	    }
		
 	}
	
}
                                                                                     
// Ganz kurze Pause machen, ca. 12.5 ms bei 8 Mhz
void delay (short int dauer)
{                         
	int inner,outer;		// Zhlvariablen
	
	for (outer=dauer;outer>0;outer--)  // Outer*0.7ms bei 8 Mhz
	 for (inner=255;inner>0;inner--);
	
} // end of delay 
          
               
// Sendet ein Acknowledge
void send_acknowledge (void)
{                     
	// Transmitter auf senden schalten
	PORTD|=32; // PD 5 auf High ziehen
	     
	// Kurze Pause fr den Bus
	delay (18);
	
    //  TXC auf Null setzen durch berschreiben mit 1
    USR|=64;
    
   	// Slaveadresse senden
   	UDR=Slaveadresse;

    // Warten, bis das Zeichen raus ist....
    delay (18);
    
	//  TXC auf Null setzen durch berschreiben mit 1
    USR|=64;
    
	// Kommando hinterher schieben
	UDR=Kommando;
	
	// Hier noch warten, bis die Bytes raus sind
    // Warten, bis das Zeichen raus ist....
    delay (18);
     
	// Transmitter wieder abschalten
	PORTD&=223; // PD 5 auf Low ziehen
}

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B
DDRB=0xFF;
PORTB=0x00;
  
// Port D
DDRD=32;  // Alles Eingang, PD5 Ausgang
PORTD=0; 

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 9,766 kHz
// Mode: Output Compare
// OC0 output: Disconnected
// TCCR0=0x05; // 00000101 run
TCCR0=0x00; // 00000000 stopped
TCNT0=0x00;
   
// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 39,063 kHz
// Mode: 8 bit Pulse Width Modulation
// OC1 output: Inverted
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0xC1;
TCCR1B=0x04;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1H=0x00;
OCR1AL=0xff;			// PWM-Startwert, entspricht 0%
             
// UART initialization
// Communication Parameters: 9 Data, 1 Stop, No Parity
// UART Receiver: On
// UART Transmitter: On
UCR=0x1C;
// UART Baud rate: 9600 @ 10 MHz
UBRR=0x40;               
           
// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x02;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
            
// Global enable interrupts
#asm("sei")

while (1)
      {
      // Place your code here
  	   
      // Warten auf empfangenes Zeichen 
      while (!(USR & 0x80)) 
      {                                 
      }
      // Ist das 9. Datenbit gesetzt und die Slaveadresse gltig ?
      if ( (UDR==Slaveadresse) && ( UCR & 0x02) )
      {                                 
       // OK, wir sollten uns nun also angesprochen fhlen und den Arsch vom Sofa erheben.......
       
       // Warten auf Kommando
       while (!(USR & 0x80)) 
       {                               
       }	
       Kommando=UDR;
                                                            
       // Hier gelandet ist also der Slave korrekt angesprochen und das Kommando ist auch 
       // schon rbergekommen
       
       // send_acknowledge ();
                
       // Jetzt kann mit der Dekodierung begonnen werden
  
  	   switch (Kommando)
       {              
        
        case command_switch:           // Lampe direkt ansteuern
        	 {      
                // Warten auf das nchste Zeichen
     		   while (!(USR & 0x80)) 
       		    {                               
       		    }	
       		  Datum=UDR;      // (0-100% Helligkeit)   
       		  
       		  TCCR0=0x00; // Timer 0 anhalten
                     		  
       		  // Wert umrechnen  
       		  OCR1AL=( 255- (Datum*2.5) ); // Von % in Timerwert umrechnen und Register sofort setzen
       		  
        	  send_acknowledge ();		// Aknowledge rauschieben
        	  break;
        	 }
        
        case command_dimm_abs:          // Lampe absolut dimmen
        	 {                                                   
        	 
        	  // Warten auf das nchste Zeichen (Startwert)
     		   while (!(USR & 0x80)) 
       		    {                               
       		    }	
       		  startwert=UDR;      // (0-100% Helligkeit)   

        	  // Warten auf das nchste Zeichen (Endwert)
     		   while (!(USR & 0x80)) 
       		    {                               
       		    }	
       		  endwert=UDR;      // (0-100% Helligkeit)   
                 
       		  // Warten auf das nchste Zeichen (Dauer in 0.1s)
     		   while (!(USR & 0x80))                          
       		    {                               
       		    }	
       		  dauer=UDR;      // (0-100% Helligkeit)        *)
       		  
       	   //	  startwert=0;
       	   //	  endwert=100;
       	   //	  dauer=255;
       		  
       		  // Umrechnung von % in Registerwerte
       		  startwert=( 255- (startwert*2.5) ); 
       		  endwert=( 255- (endwert*2.5) ); 
       		                                        
			//	Berechnung der Steigung
			//	steigung=(endwert-startwert)/dauer;
       		             
       		  	// Startwert setzen
       		  	OCR1AL=startwert;
       		  	
       		  	// Timer 0 starten, also das Dimmen anstossen
       		  	ticker_count=0; // Anzahl der Aufrufe bisher
       		  	TCCR0=0x03; 	// 00000011 run CK/64
       		  	                                  		  
        	  send_acknowledge ();		// Aknowledge rauschieben
        	  break;
        	 }

		case command_dimm_rel:			// Lampe relativ dimmen
			 {                          // 2 Bytes reinholen
			 
		 startwert=OCR1L;      // Aktuellen PWM-Wert holen
      			
        	  // Warten auf das nchste Zeichen (Endwert)
     		   while (!(USR & 0x80)) 
       		    {                               
       		    }	
       		  endwert=UDR;      // (0-100% Helligkeit)   
       
                 
       		  // Warten auf das nchste Zeichen (Dauer in 0.1s)
     		   while (!(USR & 0x80))                          
       		    {                               
       		    }	
       		  dauer=UDR;      // (0-100% Helligkeit)        *)
       		  
       		  // Umrechnung in Registerwerte
       		  endwert=( 255- (endwert*2.5) ); 
       		    
       		  	// Timer 0 starten, also das Dimmen anstossen
       		  	ticker_count=0; // Anzahl der Aufrufe bisher
       		  	
       		  	// Nur starten, wenn neuer Wert
       		  	if (startwert!=endwert)
       		  		TCCR0=0x03; 	// 00000011 run CK/64
       		            
       		  while (1)
       		  {
       		  }
       		                    			 
			  send_acknowledge ();		// Aknowledge rauschieben
        	  break;
       		 }

        case command_ident:				// Gert identifizieren
			 {                          
			  send_acknowledge ();		// Aknowledge rauschieben
        	  break;
       		 }

   			 
       } // Von Switch 
       
       } // Von gltiger Slaveadresse mit 9. Datenbit gesetzt
       
      };
}
